searchData={"items":[{"type":"task","title":"mix moebius.create","doc":"Creates the database","ref":"Mix.Tasks.Moebius.Create.html"},{"type":"function","title":"Mix.Tasks.Moebius.Create.run/1","doc":"","ref":"Mix.Tasks.Moebius.Create.html#run/1"},{"type":"task","title":"mix moebius.drop","doc":"Drops the database","ref":"Mix.Tasks.Moebius.Drop.html"},{"type":"function","title":"Mix.Tasks.Moebius.Drop.run/1","doc":"","ref":"Mix.Tasks.Moebius.Drop.html#run/1"},{"type":"task","title":"mix moebius.migrate","doc":"Migrates the database","ref":"Mix.Tasks.Moebius.Migrate.html"},{"type":"function","title":"Mix.Tasks.Moebius.Migrate.run/1","doc":"","ref":"Mix.Tasks.Moebius.Migrate.html#run/1"},{"type":"task","title":"mix moebius.seed","doc":"Seeds the database","ref":"Mix.Tasks.Moebius.Seed.html"},{"type":"function","title":"Mix.Tasks.Moebius.Seed.run/1","doc":"","ref":"Mix.Tasks.Moebius.Seed.html#run/1"},{"type":"module","title":"Moebius","doc":"","ref":"Moebius.html"},{"type":"function","title":"Moebius.get_connection/0","doc":"","ref":"Moebius.html#get_connection/0"},{"type":"function","title":"Moebius.get_connection/1","doc":"","ref":"Moebius.html#get_connection/1"},{"type":"function","title":"Moebius.parse_connection/1","doc":"","ref":"Moebius.html#parse_connection/1"},{"type":"function","title":"Moebius.pool_opts/0","doc":"","ref":"Moebius.html#pool_opts/0"},{"type":"function","title":"Moebius.run_with_psql/2","doc":"A convenience tool for assembling large queries with multiple commands which we use for testing.\nThese functions hand off to PSQL because Postgrex can't run more than\none command per query.","ref":"Moebius.html#run_with_psql/2"},{"type":"function","title":"Moebius.set_env/1","doc":"","ref":"Moebius.html#set_env/1"},{"type":"function","title":"Moebius.start/2","doc":"","ref":"Moebius.html#start/2"},{"type":"module","title":"Moebius.BulkCommand","doc":"","ref":"Moebius.BulkCommand.html"},{"type":"module","title":"Moebius.CommandBatch","doc":"","ref":"Moebius.CommandBatch.html"},{"type":"module","title":"Moebius.Database","doc":"","ref":"Moebius.Database.html"},{"type":"function","title":"Moebius.Database.execute/1","doc":"","ref":"Moebius.Database.html#execute/1"},{"type":"function","title":"Moebius.Database.execute/2","doc":"Executes a command for a given transaction specified with `pid`. If the execution fails,\nit will be caught in `Query.transaction/1` and reported back using `{:error, err}`.","ref":"Moebius.Database.html#execute/2"},{"type":"function","title":"Moebius.Database.start_link/1","doc":"","ref":"Moebius.Database.html#start_link/1"},{"type":"module","title":"Moebius.Db","doc":"","ref":"Moebius.Db.html"},{"type":"function","title":"Moebius.Db.all/1","doc":"","ref":"Moebius.Db.html#all/1"},{"type":"function","title":"Moebius.Db.child_spec/1","doc":"","ref":"Moebius.Db.html#child_spec/1"},{"type":"function","title":"Moebius.Db.create_document_table/1","doc":"","ref":"Moebius.Db.html#create_document_table/1"},{"type":"function","title":"Moebius.Db.create_document_table/2","doc":"","ref":"Moebius.Db.html#create_document_table/2"},{"type":"function","title":"Moebius.Db.find/2","doc":"","ref":"Moebius.Db.html#find/2"},{"type":"function","title":"Moebius.Db.first/1","doc":"","ref":"Moebius.Db.html#first/1"},{"type":"function","title":"Moebius.Db.one/1","doc":"","ref":"Moebius.Db.html#one/1"},{"type":"function","title":"Moebius.Db.prepare_extensions/1","doc":"","ref":"Moebius.Db.html#prepare_extensions/1"},{"type":"function","title":"Moebius.Db.run/1","doc":"","ref":"Moebius.Db.html#run/1"},{"type":"function","title":"Moebius.Db.run/2","doc":"","ref":"Moebius.Db.html#run/2"},{"type":"function","title":"Moebius.Db.run/3","doc":"","ref":"Moebius.Db.html#run/3"},{"type":"function","title":"Moebius.Db.run_batch/1","doc":"","ref":"Moebius.Db.html#run_batch/1"},{"type":"function","title":"Moebius.Db.save/2","doc":"","ref":"Moebius.Db.html#save/2"},{"type":"function","title":"Moebius.Db.save/3","doc":"","ref":"Moebius.Db.html#save/3"},{"type":"function","title":"Moebius.Db.start_link/1","doc":"","ref":"Moebius.Db.html#start_link/1"},{"type":"function","title":"Moebius.Db.transact_batch/1","doc":"","ref":"Moebius.Db.html#transact_batch/1"},{"type":"function","title":"Moebius.Db.transaction/1","doc":"","ref":"Moebius.Db.html#transaction/1"},{"type":"module","title":"Moebius.DocumentCommand","doc":"","ref":"Moebius.DocumentCommand.html"},{"type":"module","title":"Moebius.DocumentQuery","doc":"If you like your Postgres doing document goodness, then you'll want to use this interface. Just include it in your module\nand you can work directly with JSONB in PostgreSQL. We've tried to keep reasonable parity with\nthe Query interface, but there are some concepts here that are a bit different.\n\nThis entire module is predicated on a very particular structure for your document table. You don't need to\ncreate this table yourself, we'll do it for you on `save/2` if it does not exist.\n\nIf you want to create it yourself, the SQL is:\n\n```sql\ncreate table NAME(\n  id serial primary key not null,\n  body jsonb not null,\n  search tsvector,\n  created_at timestamptz not null default now(),\n  updated_at timestamptz\n);\n\n-- index the search and jsonb fields\ncreate index idx_NAME_search on NAME using GIN(search);\ncreate index idx_NAME on NAME using GIN(body jsonb_path_ops);\n```\n\nUsing this structure we can apply some convention, making this interface particularly compelling. Of primary note is the Full Text search,\nthis ability (and speed) is what sets PostgreSQL above other document systems.","ref":"Moebius.DocumentQuery.html"},{"type":"function","title":"Moebius.DocumentQuery.contains/2","doc":"This is analogous to `filter` with the Query module, however this method is highly optimized for JSONB as it uses the `@` (contains)\noperator. This flexes the GIN index created for your table (see above).\n\ncriteria:   -     A list of elements to look for. This list must be complete, partial matches won't work.\n\nExample:\n\n```\ndb(:user_docs)\n  |> contains(email: \"test@test.com\")\n  |> first\n```","ref":"Moebius.DocumentQuery.html#contains/2"},{"type":"function","title":"Moebius.DocumentQuery.db/1","doc":"Specifies the table or view you want to query. 'with' is an alias for the `db/1` function using\na string as a table name. This is useful for specifying a table within a schema.\n\n:table  -   the name of the table you want to query, such as `:users` or `membership.user_docs`\n\nExample\n\n```\nresult = db(:users)\n  |> to_list\n\nresult = with(\"membership.user_docs\")\n|> to_list\n```","ref":"Moebius.DocumentQuery.html#db/1"},{"type":"function","title":"Moebius.DocumentQuery.decide_command/2","doc":"","ref":"Moebius.DocumentQuery.html#decide_command/2"},{"type":"function","title":"Moebius.DocumentQuery.delete/1","doc":"- Deletes a document based on the filter (if any)\n- Deletes a document with the given id","ref":"Moebius.DocumentQuery.html#delete/1"},{"type":"function","title":"Moebius.DocumentQuery.delete/2","doc":"","ref":"Moebius.DocumentQuery.html#delete/2"},{"type":"function","title":"Moebius.DocumentQuery.delete/3","doc":"","ref":"Moebius.DocumentQuery.html#delete/3"},{"type":"function","title":"Moebius.DocumentQuery.exists/3","doc":"Queries a table using the existence operator. Not a good query to run on a large table as it needs to do a full scan in order to match,\nand can't use the built-in index, however if you need to query embedded arrays this is a good choice. If possible, use `contains/2`\n\nExample:\n\n```\nreturn = db(:user_docs)\n  |> exists(:pets, \"skippy\") # :pets is an array\n  |> to_list\n```","ref":"Moebius.DocumentQuery.html#exists/3"},{"type":"function","title":"Moebius.DocumentQuery.filter/3","doc":"Queries a table using matching string criteria. Not a good query to run on a large table as it needs to do a full scan in order to match,\nand can't use the built-in index, however if you need to do a specialized query this is a good choice. If possible, use `contains/2`\n\nExample:\n\n```\nreturn = db(:user_docs)\n  |> filter(\"body -> 'email' = $1\", res.email)\n  |> first\n```","ref":"Moebius.DocumentQuery.html#filter/3"},{"type":"function","title":"Moebius.DocumentQuery.filter/4","doc":"Queries a table using matching criteria. Not a good query to run on a large table as it needs to do a full scan in order to match,\nand can't use the built-in index, however if you need to do a specialized query this is a good choice. If possible, use `contains/2`\n\nExample:\n\n```\nreturn = db(:user_docs)\n  |> filter(:id, \">\", 100)\n  |> to_list\n```","ref":"Moebius.DocumentQuery.html#filter/4"},{"type":"function","title":"Moebius.DocumentQuery.find/2","doc":"Finds a document based on ID using the Primary Key index. An optimized query for finding a single document.\n\nExample:\n\n```\nreturn = db(:user_docs)\n  |> find(12)\n```","ref":"Moebius.DocumentQuery.html#find/2"},{"type":"function","title":"Moebius.DocumentQuery.insert/2","doc":"","ref":"Moebius.DocumentQuery.html#insert/2"},{"type":"function","title":"Moebius.DocumentQuery.limit/2","doc":"Alias for Query limit","ref":"Moebius.DocumentQuery.html#limit/2"},{"type":"function","title":"Moebius.DocumentQuery.offset/2","doc":"Alias for Query offset","ref":"Moebius.DocumentQuery.html#offset/2"},{"type":"function","title":"Moebius.DocumentQuery.remove/1","doc":"- An alias for `delete/1`, removes a document based on the filter setup.\n- An alias for `delete/2`, removes a document with the specified ID.","ref":"Moebius.DocumentQuery.html#remove/1"},{"type":"function","title":"Moebius.DocumentQuery.remove/2","doc":"","ref":"Moebius.DocumentQuery.html#remove/2"},{"type":"function","title":"Moebius.DocumentQuery.remove/3","doc":"","ref":"Moebius.DocumentQuery.html#remove/3"},{"type":"function","title":"Moebius.DocumentQuery.search/2","doc":"Performs a highly-tuned Full Text query on the indexed `search` column. This is set on `save/3`.\n\nExample:\n\n```\nusers = db(:user_docs)\n  |> search(\"test.com\")\n```\n\nPerforms a Full Text query using a full table scan. Not a good choice for larger tables. If possible,\nspecify your search columns on `save/3` and use `search/2`.\n\nExample:\n\n```\nusers = db(:user_docs)\n  |> search(for: \"test.com\", in: [:email])\n```","ref":"Moebius.DocumentQuery.html#search/2"},{"type":"function","title":"Moebius.DocumentQuery.searchable/1","doc":"Marks a set of fields for indexing during save.\n\nExample:\n\n```\nproduct = %{sku: \"TEST_1\", name: \"Test Product\", description: \"Just a test\"}\nreturn = db(:products)\n  |> searchable([:name, :description])\n  |> save(product)\n```","ref":"Moebius.DocumentQuery.html#searchable/1"},{"type":"function","title":"Moebius.DocumentQuery.searchable/2","doc":"","ref":"Moebius.DocumentQuery.html#searchable/2"},{"type":"function","title":"Moebius.DocumentQuery.select/1","doc":"Creates a SELECT command based on the assembled pipeline.","ref":"Moebius.DocumentQuery.html#select/1"},{"type":"function","title":"Moebius.DocumentQuery.sort/3","doc":"Sorts the query based on the supplied criteria.\n\nExample:\n\n```\nreturn = db(:user_docs)\n  |> exists(:pets, \"skippy\") # :pets is an array\n  |> sort(:city)\n  |> to_list\n```","ref":"Moebius.DocumentQuery.html#sort/3"},{"type":"function","title":"Moebius.DocumentQuery.update/3","doc":"","ref":"Moebius.DocumentQuery.html#update/3"},{"type":"module","title":"Moebius.Query","doc":"The main query interface for Moebius. Import this module into your code and query like a champ","ref":"Moebius.Query.html"},{"type":"function","title":"Moebius.Query.bulk_insert/2","doc":"Insert multiple rows at once, within a single transaction, returning the inserted records. Pass in a composite list, containing the rows  to be inserted.\nNote, the columns to be inserted are defined based on the first record in the list. All records to be inserted must adhere to the same schema.\n\nExample:\n\n```\ndata = [\n  [first_name: \"John\", last_name: \"Lennon\", address: \"123 Main St.\", city: \"Portland\", state: \"OR\", zip: \"98204\"],\n  [first_name: \"Paul\", last_name: \"McCartney\", address: \"456 Main St.\", city: \"Portland\", state: \"OR\", zip: \"98204\"],\n  [first_name: \"George\", last_name: \"Harrison\", address: \"789 Main St.\", city: \"Portland\", state: \"OR\", zip: \"98204\"],\n  [first_name: \"Paul\", last_name: \"Starkey\", address: \"012 Main St.\", city: \"Portland\", state: \"OR\", zip: \"98204\"],\n\n]\nresult = db(:people) |> insert(data)\n```","ref":"Moebius.Query.html#bulk_insert/2"},{"type":"function","title":"Moebius.Query.count/1","doc":"Executes a COUNT query based on the assembled pipeline. Analogous to `map/reduce(:count)`. Returns an integer.\n\nExample:\n\ncount =\n  db(:users)\n  |> limit(20)\n  |> count\n  |> single\n\n#count == 20","ref":"Moebius.Query.html#count/1"},{"type":"function","title":"Moebius.Query.db/1","doc":"Specifies the table or view you want to query and returns a QueryCommand struct.\n\n\"table\"  -   the name of the table you want to query, such as `membership.users`\n:table  -   the name of the table you want to query, such as `:users`\n\nExample\n\n```\nresult =\n  db(:users)\n  |> to_list\n\nresult =\n  db(\"membership.users\")\n  |> to_list\n```\n\nOr if you prefer more SQL-like syntax, you can use _from_, which is an alias for _db_:\n\n```\nresult =\n  from(:users)\n  |> to_list\n```","ref":"Moebius.Query.html#db/1"},{"type":"function","title":"Moebius.Query.delete/1","doc":"Creates a DELETE command","ref":"Moebius.Query.html#delete/1"},{"type":"function","title":"Moebius.Query.filter/2","doc":"","ref":"Moebius.Query.html#filter/2"},{"type":"function","title":"Moebius.Query.filter/3","doc":"","ref":"Moebius.Query.html#filter/3"},{"type":"function","title":"Moebius.Query.from/1","doc":"","ref":"Moebius.Query.html#from/1"},{"type":"function","title":"Moebius.Query.function/1","doc":"Executes a function with the given name, passed as an atom.\n\nExample:\n```\nresult =\n  db(:users)\n  |> function(:all_users)\n```","ref":"Moebius.Query.html#function/1"},{"type":"function","title":"Moebius.Query.function/2","doc":"Executes a function with the given name, passed as an atom.\n\nparams:   -   An array of values to be passed to the function.\n\nExample:\n\n```\nresult =\n  db(:users)\n  |> function(:friends, [\"mike\", \"jane\"])\n```","ref":"Moebius.Query.html#function/2"},{"type":"function","title":"Moebius.Query.function_command/2","doc":"Creates a function command","ref":"Moebius.Query.html#function_command/2"},{"type":"function","title":"Moebius.Query.group/2","doc":"Specifies a GROUP BY for a `map/reduce` (aggregate) query.\n\ncols  -   An atom indicating the column to GROUP BY. Will also be part of the SELECT list.\n\nExample:\n\n```\nresult =\n  db(:users)\n  |> map(\"money_spent > 100\")\n  |> group(:company)\n  |> reduce(:sum, :money_spent)\n```\n\nSpecifies a GROUP BY for a `map/reduce` (aggregate) query that is a string.\n\ncols  -   A string specifying the column to GROUP BY. Will also be part of the SELECT list.\n\nExample:\n\n```\nresult =\n  db(:users)\n  |> map(\"money_spent > 100\")\n  |> group(\"company, state\")\n  |> reduce(:sum, :money_spent)\n```","ref":"Moebius.Query.html#group/2"},{"type":"function","title":"Moebius.Query.insert/2","doc":"Creates an insert command based on the assembled pipeline","ref":"Moebius.Query.html#insert/2"},{"type":"function","title":"Moebius.Query.join/3","doc":"Build a table join for your query. There are a number of options to handle various joins.\nJoins can also be piped for multiple joins.\n\n:join        - set the type of join. LEFT, RIGHT, FULL, etc. defaults to INNER\n:on          - specify the table to join on\n:foreign_key - specify the tables foreign key column\n:primary_key - specify the joining tables primary key column\n:using       - used to specify a USING queries list of columns to join on\n\nExample of simple join (assumes primary key is \"id\" and foreign key is \"customer_id\"):\n```\n  cmd =\n    db(:customer)\n    |> join(:order)\n    |> select\n```\n\n Example specifying the primary key (customer.customer_id):\n```\n  cmd =\n    db(:customer)\n    |> join(:order, primary_key: :customer_id)\n    |> select\n```\n\n Example specifying the foreign key (order.customer_number):\n```\n  cmd =\n    db(:customer)\n    |> join(:order, foreign_key: :customer_number)\n    |> select\n```\n\nExample of multiple table joins:\n```\n  cmd =\n    db(:customer)\n    |> join(:order, on: :customer)\n    |> join(:item, on: :order)\n    |> select\n```\n\nExample of outer joins:\n```\n  cmd =\n      db(:customer)\n      |> join(:order, join: :left)\n      |> select\n```","ref":"Moebius.Query.html#join/3"},{"type":"function","title":"Moebius.Query.last/2","doc":"Executes a given pipeline and returns the last matching result. You should specify a `sort` to be sure first works as intended.\ncols  -   Any columns (specified as a string) that you want to have aliased or restricted in your return.\n          For example `now() as current_time, name, description`. Defaults to \"*\"\nExample:\n```\ncheap_skate =\n  db(:users)\n  |> sort(:money_spent, :desc)\n  |> last(\"first, last, email\")\n```","ref":"Moebius.Query.html#last/2"},{"type":"function","title":"Moebius.Query.limit/2","doc":"Sets the limit of the return.\n\nbound   -   And integer limiter\n\nExample:\n\n```\nresult =\n  db(:users)\n  |> limit(20)\n  |> to_list\n```","ref":"Moebius.Query.html#limit/2"},{"type":"function","title":"Moebius.Query.map/2","doc":"An alias for `filter`, specifies a range to rollup on for an aggregate query using a WHERE statement.\n\ncriteria  -   A string, atom or list (see `filter`)\n\nExample:\n\n```\nresult =\n  db(:users)\n  |> map(\"money_spent > 100\")\n  |> reduce(:sum, :money_spent)\n```","ref":"Moebius.Query.html#map/2"},{"type":"function","title":"Moebius.Query.offset/2","doc":"Offsets the limit and is an alias for `skip/1`\"\n\nExample:\n\n```\nresult =\n  db(:users)\n  |> limit(20)\n  |> offset(2)\n  |> to_list\n```","ref":"Moebius.Query.html#offset/2"},{"type":"function","title":"Moebius.Query.order_by/2","doc":"","ref":"Moebius.Query.html#order_by/2"},{"type":"function","title":"Moebius.Query.order_by/3","doc":"","ref":"Moebius.Query.html#order_by/3"},{"type":"function","title":"Moebius.Query.reduce/3","doc":"A rollup operation that aggregates the mapped result set by the specified operation.\n\nop  -   An atom indicating what you want to have happen, such as `:sum`, `:avg`, `:min`, `:max`.\n        Corresponds directly to a PostgreSQL rollup function.\n\nExample:\n\n```\nresult =\n  db(:users)\n  |> map(\"money_spent > 100\")\n  |> reduce(:sum, :money_spent)\n```","ref":"Moebius.Query.html#reduce/3"},{"type":"function","title":"Moebius.Query.search/2","doc":"Full text search using Postgres' built in indexing, ranked using `tsrank`. This query will result in a full table scan and is not optimized for large result\nsets. For better results, create a `tsvector` field and populate it with a trigger on insert/update. This will cause some side\neffects, one of them being that Postgrex, the Elixir driver we use, doesn't know how to resolve the tsvector type, and will throw.\n\nYou will need to be sure that you exclude that search column from your query.\n\nfor:  -   The string term you want to query against.\nin:   -   An atomized list of columns to search against.\n\nExample:\n\n```\nresult =\n  db(:users)\n  |> search(for: \"Mike\", in: [:first, :last, :email])\n  |> run\n```","ref":"Moebius.Query.html#search/2"},{"type":"function","title":"Moebius.Query.select/2","doc":"Creates a SELECT command based on the assembled pipeline. Uses the QueryCommand as its core structure.\n\ncols  -   Any columns (specified as a string or list) that you want to have aliased or restricted in your return.\n          For example `now() as current_time, name, description`, `[\"name\", \"description\"]` or `[:name, :description]`\n\nExample of String:\n```\ncommand =\n  db(:users)\n  |> limit(20)\n  |> offset(2)\n  |> select(\"now() as current_time, name, description\")\n\n#command is a QueryCommand object with all of the pipelined settings applied\n```\n\nExample of List:\n```\ncommand =\n  db(:users)\n  |> limit(20)\n  |> offset(2)\n  |> select([:name, :description])\n\n#command is a QueryCommand object with all of the pipelined settings applied\n```","ref":"Moebius.Query.html#select/2"},{"type":"function","title":"Moebius.Query.skip/2","doc":"Offsets the limit and is an alias for `offset/1`\"\n\nExample:\n\n```\nresult =\n  db(:users)\n  |> limit(20)\n  |> skip(2)\n  |> to_list\n```","ref":"Moebius.Query.html#skip/2"},{"type":"function","title":"Moebius.Query.sort/2","doc":"","ref":"Moebius.Query.html#sort/2"},{"type":"function","title":"Moebius.Query.sort/3","doc":"Sets the order by. Ascending using `:asc` is the default, you can send in `:desc` if you like.\n\ncol             -  The atomized name of the column, such as `:company`\ndir (optional)  -  `:asc` (default) or `:desc`\n\nExample of single order by:\n```\nresult =\n  db(:users)\n  |> sort(:name, :desc)\n  |> to_list\n```\n\nExample of multiple order by:\n```\nresult =\n  db(:users)\n  |> sort(id: :asc, name: :desc)\n  |> to_list\n```\n\nOr if you prefer more SQL-like syntax, you can use \"order_by\", which is an alias for \"sort\":\n\n```\nresult =\n  db(:users)\n  |> order_by(id: :asc, name: :desc)\n  |> to_list\n```","ref":"Moebius.Query.html#sort/3"},{"type":"function","title":"Moebius.Query.sql_file/1","doc":"Executes the SQL in a given SQL file without parameters. Specify the scripts directory by setting the `scripts` directive in the config.\nPass the file name as an atom, without extension.\n\n```\nresult = sql_file(:simple)\n```","ref":"Moebius.Query.html#sql_file/1"},{"type":"function","title":"Moebius.Query.sql_file/2","doc":"Executes the SQL in a given SQL file with the specified parameters. Specify the scripts\ndirectory by setting the `scripts` directive in the config. Pass the file name as an atom,\nwithout extension.\n\n```\nresult = sql_file(:save_user, [1])\n```","ref":"Moebius.Query.html#sql_file/2"},{"type":"function","title":"Moebius.Query.sql_file_command/2","doc":"Creates a SQL File command","ref":"Moebius.Query.html#sql_file_command/2"},{"type":"function","title":"Moebius.Query.update/2","doc":"Creates an update command based on the assembled pipeline.","ref":"Moebius.Query.html#update/2"},{"type":"function","title":"Moebius.Query.where/2","doc":"","ref":"Moebius.Query.html#where/2"},{"type":"function","title":"Moebius.Query.where/3","doc":"","ref":"Moebius.Query.html#where/3"},{"type":"module","title":"Moebius.QueryCommand","doc":"Struct for the query command which is piped through all the transforms","ref":"Moebius.QueryCommand.html"},{"type":"module","title":"Moebius.QueryFilter","doc":"The QueryFilter module is used to build WHERE clauses to be used in queries. You can\ncall it directly but in most cases it will be used through the Query module (see Query module).\n\nHere is an example of adding a predicate to match an email address:\n\n  iex> cmd = %Moebius.QueryCommand{table_name: 'users'}\n  iex> cmd = Moebius.QueryFilter.filter(cmd, email: \"test@test.com\")\n  iex> cmd.where\n  \" where email = $1\"\n  iex> cmd.params\n  [\"test@test.com\"]\n\nOr if you prefer a more SQL-like syntax, you can use \"where\", which is an alias for \"filter\":\n\n  iex> cmd = Moebius.QueryFilter.where(cmd, email: \"test@test.com\")\n\nAlthough there are more examples in the Moebius.Query module here are a few to show filters in\naction:\n\n  Basic Select:\n\n  iex> import Moebius.Query\n  iex> cmd = db(:users) |>\n  ...>   filter(email: \"test@test.com\") |>\n  ...>   select\n  iex> cmd.sql\n  \"select * from users where email = $1;\"\n  iex> cmd.params\n  [\"test@test.com\"]\n\n  Basic Select using '>' Operator:\n\n  iex> import Moebius.Query\n  iex> cmd = db(:users) |>\n  ...>   filter(:order_count, gt: 5) |>\n  ...>   select\n  iex> cmd.sql\n  \"select * from users where order_count > $1;\"\n  iex> cmd.params\n  [\"phillip\", \"lela\", \"bender\"]\n\n  Basic Select using 'IN' Operator:\n\n  iex> import Moebius.Query\n  iex> cmd = db(:users) |>\n  ...>   filter(:name, in: [\"phillip\", \"lela\", \"bender\"]) |>\n  ...>   select\n  iex> cmd.sql\n  \"select * from users where name IN($1, $2, $3);\"\n  iex> cmd.params\n  [\"phillip\", \"lela\", \"bender\"]\n\n  All available Operators:\n\n  - \"=\": eq\n  - \"!=\": neq\n  - \">\": gt\n  - \"<\": lt\n  - \">=\": gte\n  - \"<=\": lte\n  - \"IN\": in\n  - \"NOT IN\": not_in (or nin)\n\n  Basic Select using string:\n\n  iex> import Moebius.Query\n  iex> cmd = db(:users) |>\n  ...>   filter(\"email LIKE $1\", \"%test.com%\") |>\n  ...>   select\n  iex> cmd.sql\n  \"select * from users where email LIKE $1;\"\n  iex> cmd.params\n  [\"%test.com%\"]\n\nFilters can also be piped:\n\n  iex> import Moebius.Query\n  iex> cmd = db(:users) |>\n  ...>  filter(\"email LIKE $1\", \"%test.com%\") |>\n  ...>  filter(:name, not_in: [\"phillip\", \"lela\", \"bender\"]) |>\n  ...>  filter(:order_count, gt: 5) |>\n  ...>  select\n  iex> cmd.sql\n  \"select * from users where email LIKE $1 and name NOT IN($2, $3, $4) and order_count > $5;\"\n  iex> cmd.params\n  [\"%test.com%\", \"phillip\", \"lela\", \"bender\"]","ref":"Moebius.QueryFilter.html"},{"type":"function","title":"Moebius.QueryFilter.filter/2","doc":"","ref":"Moebius.QueryFilter.html#filter/2"},{"type":"function","title":"Moebius.QueryFilter.filter/3","doc":"","ref":"Moebius.QueryFilter.html#filter/3"},{"type":"function","title":"Moebius.QueryFilter.where/2","doc":"","ref":"Moebius.QueryFilter.html#where/2"},{"type":"function","title":"Moebius.QueryFilter.where/3","doc":"","ref":"Moebius.QueryFilter.html#where/3"},{"type":"module","title":"Moebius.Transformer","doc":"The results that come back from Postgrex are in a bit of a convoluted form with string key maps that aren't terribly useful.\nThis module restructures the results.","ref":"Moebius.Transformer.html"},{"type":"function","title":"Moebius.Transformer.atomize_columns/1","doc":"","ref":"Moebius.Transformer.html#atomize_columns/1"},{"type":"function","title":"Moebius.Transformer.format_ok_result/1","doc":"","ref":"Moebius.Transformer.html#format_ok_result/1"},{"type":"function","title":"Moebius.Transformer.from_json/1","doc":"","ref":"Moebius.Transformer.html#from_json/1"},{"type":"function","title":"Moebius.Transformer.from_json/2","doc":"","ref":"Moebius.Transformer.html#from_json/2"},{"type":"function","title":"Moebius.Transformer.match_columns_to_row/2","doc":"","ref":"Moebius.Transformer.html#match_columns_to_row/2"},{"type":"function","title":"Moebius.Transformer.to_list/1","doc":"","ref":"Moebius.Transformer.html#to_list/1"},{"type":"function","title":"Moebius.Transformer.to_map/1","doc":"","ref":"Moebius.Transformer.html#to_map/1"},{"type":"function","title":"Moebius.Transformer.to_single/1","doc":"","ref":"Moebius.Transformer.html#to_single/1"},{"type":"extras","title":"README","doc":"","ref":"readme.html"},{"type":"extras","title":"A functional query tool for Elixir and PostgreSQL. - README","doc":"Our goal with creating Moebius is to try and keep as close as possible to the functional nature of Elixir and, at the same time, the goodness that is PostgreSQL. We think working with a database should feel like a natural extension of the language, with as little abstraction wonkery as possible.\n\nMoebius is *not* an ORM. There are no mappings, no schemas, no migrations; only queries and data. We embrace PostgreSQL as much as possible, surfacing the goodness so you be a hero.","ref":"readme.html#a-functional-query-tool-for-elixir-and-postgresql"},{"type":"extras","title":"Documentation - README","doc":"API documentation is available at http://hexdocs.pm/moebius","ref":"readme.html#documentation"},{"type":"extras","title":"Installation - README","doc":"Installing Moebius involves a few small steps:\n\n  1. Add moebius to your list of dependencies in `mix.exs`:\n\n   ```elixir\n    def deps do\n      [{:moebius, \"~> 4.0.2\"}]\n    end\n   ```\n\n  2. Add the db child process to your `Application` module's supervision tree:\n  \n  ```elixir\n  children = [\n    Moebius.Db\n  ]\n  ```\n\nRun `mix deps.get` and you'll be good to go.","ref":"readme.html#installation"},{"type":"extras","title":"Connecting to PostgreSQL - README","doc":"There are various ways to connect to a database with Moebius. You can used a formal, supervised definition or just roll with our default. Either way, you start off by adding connection info in your `config.exs`:\n\n```elixir\nconfig :moebius, connection: [\n  hostname: \"localhost\",\n  username: \"username\",\n  password: \"password\",\n  database: \"my_db\"\n],\nscripts: \"test/db\"\n```\n\nYou can also use a URL if you like:\n\n```elixir\nconfig :moebius, connection: [\n  url: \"postgresql://user:password@host/database\"\n],\nscripts: \"test/db\"\n```\n\nYou can also configure custom [Postgres Extensions](https://hexdocs.pm/postgrex/Postgrex.Extension.html#content):\n\n```elixir\nconfig :moebius,\n  connection: [url: \"postgresql://user:password@host/database\"],\n  types: PostgresTypes\n```\n\nAnd define your custom types in your application under `lib/postgres_types.ex`\n\n```elixir\ntypes = [Geo.PostGIS.Extension, Some.Custom.Extension]\nopts = [json: Jason]\n\nPostgrex.Types.define(PostgresTypes, types, opts)\n```\n\nIf you want to use environment variables, just set things using `System.env`.\n\nUnder the hood, Moebius uses [the Postgrex driver](https://github.com/ericmj/postgrex) to manage connections and connection pooling. Connections are supervised, so if there's an error any transaction pending will be rolled back effectively (more on that later). The settings you provide in `:connection` will be passed directly to Postgrex (aside from `:url`, which we parse).\n\nYou might be wondering what the `scripts` entry is? Moebius can execute SQL files directly for you - we'll get to that in a bit.","ref":"readme.html#connecting-to-postgresql"},{"type":"extras","title":"Supervision and Databases - README","doc":"Moebius formalizes the concept of a database connection, so you can supervise each independently, or not at all. This allows for a lot of flexibility. You don't have to do it this way, but it really helps.\n\n**You don't need to do any of this** - we have a default DB setup for you. However, if you want a formalized, supervised module for your database, here's how you do it.\n\nFirst, create a module for your database:\n\n```elixir\ndefmodule MyApp.Db do\n  use Moebius.Database\n\n  # helper/repo methods go here\nend\n```\n\nNext, in your `Application` file, add this new module to your supervision tree:\n\n```elixir\ndef start(_type, _args) do\n  start_db\n  #...\nend\n\ndef start_db do\n  #create a child process\n  children = [\n    {MyApp.Db, [Moebius.get_connection]}\n  ]\n  Supervisor.start_link children, strategy: :one_for_one\nend\n```\n\nThat's it. Now, when your app starts you'll have a supervised database you can use as needed. The function `Moebius.get_connection/0` will look for a key called `:connection` in your `config.exs`. If you want to connect to multiple databases, name these connections something meaningful, then pass that to `Moebius.get_connection/1`.\n\nFor instance, you might have a sales database and an accounting one; or you might have a read-only connection and a write-only one to spread the load. For this, just specify each as needed:\n\n```elixir\nconfig :moebius, read_only: [\n  url: \"postgresql://user:password@host/database\"\n],\nwrite_only: [\n  url: \"postgresql://user:password@host/database\"\n],\nscripts: \"test/db\"\n```\n\nYou can now use these in your database module:\n\n```elixir\ndef start(_type, _args) do\n  start_db\n  #...\nend\n\ndef start_db do\n  #create a worker\n  read_only_db_worker = worker(MyApp.Db, [Moebius.get_connection(:read_only)])\n  write_only_db_worker = worker(MyApp.Db, [Moebius.get_connection(:write_only)])\n  Supervisor.start_link [read_only_db_worker, write_only_db_worker], strategy: :one_for_one\nend\n```\n\nIt bears repeating: *you don't need to do any of this*, we have a default database setup for you. However supporting multiple connections was very high on our list so this is how we chose to do it (with many thanks to [Peter Hamilton](https://github.com/hamiltop) for the idea).\n\nThe rest of the examples you see below use our default database.","ref":"readme.html#supervision-and-databases"},{"type":"extras","title":"The Basic Query Flow - README","doc":"When querying the database (read or write), you construct the query and then pass it to the database you want:\n\n```elixir\n{:ok, result} = Moebius.Query.db(:users) |> Moebius.Db.first\n```\n\nIn this example, `db(:users)` initiates the `QueryCommand`, we can filter it, sort it, do all kinds of things. To run it, however, we need to pass it to the database we want to execute against.\n\nThe default database is `Moebius.Db`, but you can make your own with a dedicated connection as needed (see above).\n\nLet's see some more examples.","ref":"readme.html#the-basic-query-flow"},{"type":"extras","title":"Simple Examples - README","doc":"The API is built around the concept of transforming raw data from your database into something you need, and we try to make it feel as *functional* as possible. We lean on Elixir's `|>` operator for this, and it's the core of the API.\n\nThis returns a user with the id of 1.\n\n```elixir\n{:ok, result} =\n  db(:users)\n  |> filter(name: \"Steve\")\n  |> sort(:city, :desc)\n  |> limit(10)\n  |> offset(2)\n  |> Moebius.Db.run\n```\n\nHopefully it's fairly straightforward what this query returns. All users named Steve sorted by city... skipping the first two, returning the next 10.\n\n#","ref":"readme.html#simple-examples"},{"type":"extras","title":"Operators - README","doc":"An \"=\" (Equal) query happens when you pass a column name and a value:\n\n```elixir\n{:ok, result} =\n  db(:users)\n  |> filter(name: \"mark\")\n  |> Moebius.Db.run\n\n# or, if you want to be more precise, specify the `eq` key:\n\n{:ok, result} =\n  db(:users)\n  |> filter(:name, eq: \"mark\"])\n  |> Moebius.Db.run\n```\n\nA \"!=\" (Not Equal) query happens when you specify the `neq` key:\n\n```elixir\n{:ok, result} =\n  db(:users)\n  |> filter(:name, neq: \"mark\")\n  |> Moebius.Db.run\n```\n\nA \">\" (Greater Than) query happens when you specify the `gt` key:\n\n```elixir\n{:ok, result} =\n  db(:users)\n  |> filter(:order_count, gt: 5)\n  |> Moebius.Db.run\n```\n\nAdditionally, the following comparison operators are available:\n\n- \"<\" (Less Than): `lt`\n- \">=\" (Greater Than or Equal To): `gte`\n- \"<=\" (Less Than or Equal To) `lte`\n\nAn \"IN\" query happens when you pass an array:\n\n```elixir\n{:ok, result} =\n  db(:users)\n  |> filter(:name, [\"mark\", \"biff\", \"skip\"])\n  |> Moebius.Db.run\n\n# or, if you want to be more precise, specify the `in` key:\n\n{:ok, result} =\n  db(:users)\n  |> filter(:name, in: [\"mark\", \"biff\", \"skip\"])\n  |> Moebius.Db.run\n```\n\nA \"NOT IN\" query happens when you specify the `not_in` or `nin` key:\n\n```elixir\n{:ok, result} =\n  db(:users)\n  |> filter(:name, not_in: [\"mark\", \"biff\", \"skip\"])\n  |> Moebius.Db.run\n```\n\nIf you prefer a more SQL-like syntax, you can use the following aliases:\n\n- db: `from`\n- filter: `where`\n- sort: `order_by`\n\n```elixir\n{:ok, result} =\n  from(:users)\n  |> where(name: \"Steve\")\n  |> where(:order_count, gt: 5)\n  |> order_by(id: :asc, name: :desc)\n```\n\nIf you don't want to deal with my abstractions, just use SQL:\n\n```elixir\n{:ok, result} = \"select * from users where id=1 limit 1 offset 1;\" |> Moebius.Db.run\n```","ref":"readme.html#operators"},{"type":"extras","title":"Full Text indexing - README","doc":"One of the great features of PostgreSQL is the ability to do intelligent full text searches. We support this functionality directly:\n\n```elixir\n{:ok, result} =\n  db(:users)\n  |> search(for: \"Mike\", in: [:first, :last, :email])\n  |> Moebius.Db.run\n```\n\nThe `search` function builds a `tsvector` search on the fly for you and executes it over the columns you send in. The results are ordered in descending order using `ts_rank`.","ref":"readme.html#full-text-indexing"},{"type":"extras","title":"JSONB Support - README","doc":"Moebius supports using PostgreSQL as a document store in its entirety. Get your project off the ground and don't worry about migrations - just store documents, and you can normalize if you need to later on.\n\nStart by importing `Moebius.DocumentQuery` and saving a document:\n\n```elixir\nimport Moebius.DocumentQuery\n\n{:ok, new_user} =\n  db(:friends)\n  |> Moebius.Db.save(email: \"test@test.com\", name: \"Moe Test\")\n```\n\nTwo things happened for us here. The first is that `friends` did not exist as a document table in our database, but `save/2` did that for us. This is the table that was created on the fly:\n\n```sql\ncreate table NAME(\n  id serial primary key not null,\n  body jsonb not null,\n  search tsvector,\n  created_at timestamptz not null default now(),\n  updated_at timestamptz not null default now()\n);\n\n-- index the search and jsonb fields\ncreate index idx_NAME_search on NAME using GIN(search);\ncreate index idx_NAME on NAME using GIN(body jsonb_path_ops);\n```\n\nThe entire `DocumentQuery` module works off the premise that this is how you will store your JSONB docs. Note the `tsvector` field? That's PostgreSQL's built in full text indexing. We can use that if we want during by adding `searchable/1` to the pipe:\n\n```elixir\nimport Moebius.DocumentQuery\n\n{:ok, new_user} =\n  db(:friends)\n  |> searchable([:name])\n  |> Moebius.Db.save(email: \"test@test.com\", name: \"Moe Test\")\n```\n\nBy specifying the searchable fields, the `search` field will be updated with the values of the name field.\n\nNow, we can query our document using full text indexing which is optimized to use the GIN index created above:\n\n```elixir\n{:ok, user} =\n  db(:friends)\n  |> search(\"test.com\")\n  |> Moebius.Db.run\n```\n\nOr we can do a simple filter:\n\n```elixir\n{:ok, user} =\n  db(:friends)\n  |> contains(email: \"test@test.com\")\n  |> Moebius.Db.run\n```\n\nThis query is optimized to use the `@` (or \"contains\" operator), using the *other* GIN index specified above. There's more we can do...\n\n```elixir\n{:ok, users} =\n  db(:friends)\n  |> filter(:money_spent, \">\", 100)\n  |> Moebius.Db.run\n```\n\nThis runs a full table scan so is not terribly optimal, but it does work if you need it once in a while. You can also use the existence (`?`) operator, which is very handy for querying arrays. In the library, it is implemented as `exists`:\n\n```elixir\n{:ok, buddies} =\n  db(:friends)\n  |> exists(:tags, \"best\")\n  |> Moebius.Db.run\n```\n\nThis will allow you to query embedded documents and arrays rather easily, but again doesn't use the JSONB-optimized GIN index. You *can* index for using existence, have a look at the PostgreSQL docs.\n\n#","ref":"readme.html#jsonb-support"},{"type":"extras","title":"Using Structs - README","doc":"If you're a big fan of structs, you can use them directly on `save` and we'll send that same struct back to you, complete with an `id`:\n\n```elixir\ndefmodule Candy do\n  defstruct [\n    id: nil,\n    sticky: true,\n    chocolate: \"gooey\"\n  ]\nend\n\nyummy = %Candy{}\n{:ok, res} = db(:monkies) |> Moebius.Db.save(yummy)\n#res = %Candy{id: 1, sticky: true, chocolate: \"gooey\"}\n```\n\nI've been using this functionality constantly with another project I'm working on and it's helped me tremendously.","ref":"readme.html#using-structs"},{"type":"extras","title":"SQL Files - README","doc":"I built this for [MassiveJS](https://github.com/robconery/massive-js) and I liked the idea, which is this: *some people love SQL*. I'm one of those people. I'd much rather work with a SQL file than muscle through some weird abstraction.\n\nWith this library you can do that. Just create a scripts directory and specify it in the config (see above), then execute your file without an extension. Pass in whatever parameters you need:\n\n```elixir\n{:ok, result} = sql_file(:my_groovy_query, \"a param\") |> Moebius.Db.run\n```\n\nI highly recommend this approach if you have some difficult SQL you want to write (like a windowing query or CTE). We use this approach to build our test database - have a look at our tests and see.","ref":"readme.html#sql-files"},{"type":"extras","title":"Adding, Updating, Deleting (Non-Documents) - README","doc":"Inserting is pretty straightforward:\n\n```elixir\n{:ok, result} =\n  db(:users)\n  |> insert(email: \"test@test.com\", first: \"Test\", last: \"User\")\n  |> Moebius.Db.run\n```\n\nUpdating can work over multiple rows, or just one, depending on the filter you use:\n\n```elixir\n{:ok, result} =\n  db(:users)\n  |> filter(id: 1)\n  |> update(email: \"maggot@test.com\")\n  |> Moebius.Db.run\n```\n\nThe filter can be a single record, or affect multiple records:\n\n```elixir\n{:ok, result} =\n  db(:users)\n  |> filter(\"id > 100\")\n  |> update(email: \"test@test.com\")\n  |> Moebius.Db.run\n\n{:ok, result} =\n  db(:users)\n  |> filter(\"email LIKE $2\", \"%test\")\n  |> update(email: \"ox@test.com\")\n  |> Moebius.Db.run\n```\n\nDeleting works exactly the same way as `update`, but returns the count of deleted items in the result:\n\n```elixir\n{:ok, result} =\n  db(:users)\n  |> filter(\"email LIKE $2\", \"%test\")\n  |> delete\n  |> Moebius.Db.run\n\n#result.deleted = 10, for instance\n```","ref":"readme.html#adding-updating-deleting-non-documents"},{"type":"extras","title":"Bulk Inserts - README","doc":"Moebius supports bulk insert operations transactionally. We've fine-tuned this capability quite a lot (thanks to [Jon Atten](https://github.com/xivsolutions)) and, on our local machines, have achieved ~60,000 writes per second. This, of course, will vary by machine, configuration, and use.\n\nBut that's still a pretty good number don't you think?\n\nA bulk insert works by invoking one directly:\n\n```elixir\ndata = [#let's say 10,000 records or so]\n{:ok, result} =\n  db(:people)\n  |> bulk_insert(data)\n  |> Moebius.Db.transact_batch\n```\n\nIf everything works, you'll get back a result indicating the number of records inserted.","ref":"readme.html#bulk-inserts"},{"type":"extras","title":"Table Joins - README","doc":"Table joins can be applied for a single join or piped to create multiple joins. The table names can be either atoms or binary strings. There are a number of options to customize your joins:\n\n```elixir\n  :join        # set the type of join. LEFT, RIGHT, FULL, etc. defaults to INNER\n  :on          # specify the table to join on\n  :foreign_key # specify the tables foreign key column\n  :primary_key # specify the joining tables primary key column\n  :using       # used to specify a USING queries list of columns to join on\n```\n\nThe simplest example is a basic join:\n\n```elixir\n{:ok, result} =\n  db(:customer)\n  |> join(:order)\n  |> select\n  |> Moebius.Db.run\n```\n\nFor multiple table joins you can specify the table that you want to join on:\n\n```elixir\n{:ok, result} =\n  db(:customer)\n  |> join(:order, on: :customer)\n  |> join(:item, on: :order)\n  |> select\n  |> Moebius.Db.run\n```","ref":"readme.html#table-joins"},{"type":"extras","title":"Transactions - README","doc":"Transactions are facilitated by using a callback that has a `pid` on it, which you'll need to pass along to each query you want to be part of the transaction. The last execution will be returned. If there's an error, an `{:error, message}` will be returned instead and a `ROLLBACK` fired on the transaction. No need to `COMMIT`, it happens automatically:\n\n```elixir\n{:ok, result} = transaction fn(pid) ->\n  new_user =\n    db(:users)\n    |> insert(pid, email: \"frodo@test.com\")\n    |> Moebius.Db.run(pid)\n\n  with(:logs)\n    |> insert(pid, user_id: new_user.id, log: \"Hi Frodo\")\n    |> Moebius.Db.run(pid)\n  new_user\nend\n```\n\nIf you're having any kind of trouble with transactions, I highly recommend you move to a SQL file or a function, which we also support. Abstractions are here to help you, but if we're in your way, by all means shove us (gently) aside.","ref":"readme.html#transactions"},{"type":"extras","title":"Aggregates - README","doc":"Aggregates are built with a functional approach in mind. This might seem a bit odd, but when working with any relational database, it's a good idea to think about gathering your data, grouping it, and reducing it. That's what you're doing whenever you run aggregation queries.\n\nSo, to that end, we have:\n\n```elixir\n{:ok, sum} =\n  db(:products)\n  |> map(\"id > 1\")\n  |> group(:sku)\n  |> reduce(:sum, :id)\n  |> Moebius.Db.run\n```\n\nThis might be a bit verbose, but it's also very very clear to whomever is reading it after you move on. You can work with any aggregate function in PostgreSQL this way (AVG, MIN, MAX, etc).\n\nThe interface is designed with *routine* aggregation in mind - meaning that there are some pretty complex things you can do with PostgreSQL queries. If you like doing that, I fully suggest you flex our SQL File functionality and write it out there - or create yourself a cool function and call it with our Function interface.","ref":"readme.html#aggregates"},{"type":"extras","title":"Functions - README","doc":"PostgreSQL allows you to do so much, especially with functions. If you want to encapsulate a good time, you can execute it with Moebius:\n\n```elixir\n{:ok, party} = function(:good_time, [me, you]) |> Moebius.Db.run\n```\n\nYou get the idea. If your function only returns one thing, you can specify you don't want an array back:\n\n```elixir\n{:ok, no_party} = function(:bad_time, :single [me]) |> Moebius.Db.run\n```","ref":"readme.html#functions"},{"type":"extras","title":"Test - README","doc":"You'll need a local postgres instance running.\n\n```bash\nMIX_ENV=test mix moebius.setup\nMIX_ENV=test mix test\n```","ref":"readme.html#test"},{"type":"extras","title":"Help? - README","doc":"I would love to have your help! I do ask that if you do find a bug, please add a test to your PR that shows the bug and how it was fixed.\n\nThanks!","ref":"readme.html#help"}],"content_type":"text/markdown"}